import java.util.*;

/**
 * This class is entirely for testing purposes...
 * It generates random SML/NG files...
 **/
public class RandomFile {
  public Vector tags = new Vector();
  public Vector whitespace = new Vector();
  public Vector tagStack = new Vector();
  
  public void init() {
    for(int c=0;c<=9;++c) {
      tags.addElement(new Character((char)('0'+c)));
    }
    tags.addElement("r");
    tags.addElement("g");
    tags.addElement("b");
    tags.addElement("c");
    tags.addElement("m");
    tags.addElement("y");
    tags.addElement("k");
    tags.addElement("w");
    
    tags.addElement("TT");
    tags.addElement("PL");
    tags.addElement("B");
    tags.addElement("I");
    tags.addElement("S");
    tags.addElement("EM");
    tags.addElement("U");

    whitespace.addElement(new Character((char)10));
    whitespace.addElement(new Character(' '));
    whitespace.addElement(new Character((char)13));
    whitespace.addElement(new Character((char)9));
  }

  public void go() {
    Random r = new Random();
    int length = Math.abs(r.nextInt())%20000;
    for(int c=0;c<length;++c) {
      int rand = r.nextInt();
      rand = rand%100;
      if (rand < 20) {
        // Whitespace...
        rand = Math.abs(r.nextInt())%4;
        System.out.print(whitespace.elementAt(rand));
      } else if (rand < 40) {
        // characters...
        int stringlen = Math.abs(r.nextInt())%10;
        for(int d=0;d<stringlen;++d) {
          System.out.print((char)('A'+Math.abs(r.nextInt())%52));
        }
      } else if (rand < 70) {
        // Tag...
        rand = Math.abs(r.nextInt())%tags.size();
        System.out.print("<" + tags.elementAt(rand) + ">");
        tagStack.addElement(tags.elementAt(rand));
      } else {
        if (tagStack.size() > 0) {
          // close a tag if possible...
          System.out.print("</" + tagStack.lastElement() + ">");
          tagStack.removeElementAt(tagStack.size()-1);
        }
      } 

    }
    // close any open tags...
    for(int c=(tagStack.size()-1);c>=0;--c) {
      System.out.print("</" + tagStack.elementAt(c) + ">");
    }
  }

  public static void main(String argv[]) {
    RandomFile rf = new RandomFile();
    rf.init();
    rf.go();

  }



}
